/*********************************************************************************************************
* Software License Agreement (BSD License)                                                               *
* Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
*													 *
* Copyright (c) 2008, WIDE Project and NICT								 *
* All rights reserved.											 *
* 													 *
* Redistribution and use of this software in source and binary forms, with or without modification, are  *
* permitted provided that the following conditions are met:						 *
* 													 *
* * Redistributions of source code must retain the above 						 *
*   copyright notice, this list of conditions and the 							 *
*   following disclaimer.										 *
*    													 *
* * Redistributions in binary form must reproduce the above 						 *
*   copyright notice, this list of conditions and the 							 *
*   following disclaimer in the documentation and/or other						 *
*   materials provided with the distribution.								 *
* 													 *
* * Neither the name of the WIDE Project or NICT nor the 						 *
*   names of its contributors may be used to endorse or 						 *
*   promote products derived from this software without 						 *
*   specific prior written permission of WIDE Project and 						 *
*   NICT.												 *
* 													 *
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED *
* WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A *
* PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR *
* ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 	 *
* LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 	 *
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR *
* TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF   *
* ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.								 *
*********************************************************************************************************/

/* Peers facility.
 *
 * This file contains the code to open the listening ports and accept new incoming connections.
 *
 * We always open two sockets for TCP and SCTP and listen on the port defined in the configuration file,
 * then create two threads waiting for incoming connections.
 *
 */

#include "waaad-internal.h"
#include "peer-internal.h"	

/* The code of a receiver thread, to handle an incoming connection */
void * _peer_receiver_th(void * arg)
{
	TRACE_ENTRY( "%p", arg );
	
	/* Wait for incoming message, until timeout */
	
	/* if message is not CER, disconnect */
	
	/* if CER, check we do not have already a peer with this diameter-id in the list */
	
	/* depending on the peer state, act as needed */
	
	TRACE_DEBUG (INFO, "@@@ %s: not implemented yet.", __FUNCTION__ );
	return NULL;
}
/* The code of the thread waiting for incoming connection. 1 thread per listening socket. */
void * _peer_listen_th(void * arg)
{
	int sock = 0;
	
	TRACE_ENTRY( "%p", arg );
	
	/* sock = *(int *)arg; */
	
	/* listen() */
	
	/* accept() */
	
	/* On new connection, create a receiver thread (_peer_receiver_th) */
	
	TRACE_DEBUG (INFO, "@@@ %s: not implemented yet.", __FUNCTION__ );
	return NULL;
}

/* Code to open a TCP socket */
int _listen_tcp(int * sock)
{
	TRACE_ENTRY( "" );
	TRACE_DEBUG (INFO, "@@@ %s: not implemented yet.", __FUNCTION__ );
	return ENOTSUP;
}
	
/* Code to open a SCTP socket */
int _listen_sctp(int * sock)
{
	TRACE_ENTRY( "" );
	TRACE_DEBUG (INFO, "@@@ %s: not implemented yet.", __FUNCTION__ );
	return ENOTSUP;
}

/* Code to start listening */
/* -- must use these --
	int		 disable_inet4;
	int		 disable_inet6;
	int		 disable_tcp;
*/
